import { LinkedListNode } from '../models/LinkedListNode';
import { LinkedListNodeInternal } from '../models/LinkedListNodeInternal';
import { Enumerable } from './Enumerable';
/**
 * Represents a linked list of objects.
 */
export declare class LinkedList<T> extends Enumerable<T> {
    protected sizeInternal: number;
    protected headInternal: LinkedListNodeInternal<T> | undefined;
    protected tailInternal: LinkedListNodeInternal<T> | undefined;
    constructor(source?: Iterable<T>);
    [Symbol.iterator](): Iterator<T>;
    get fromTail(): Enumerable<T>;
    get nodes(): Enumerable<LinkedListNode<T>>;
    get nodesFromTail(): Enumerable<LinkedListNode<T>>;
    get size(): number;
    get head(): LinkedListNode<T>;
    get headOrDefault(): LinkedListNode<T> | undefined;
    get tail(): LinkedListNode<T>;
    get tailOrDefault(): LinkedListNode<T> | undefined;
    find(value: T): LinkedListNode<T>;
    findOrDefault(value: T): LinkedListNode<T> | undefined;
    findLast(value: T): LinkedListNode<T>;
    findLastOrDefault(value: T): LinkedListNode<T> | undefined;
    addHead(value: T): void;
    addTail(value: T): void;
    addAfter(node: LinkedListNode<T> | undefined, value: T): void;
    addBefore(node: LinkedListNode<T> | undefined, value: T): void;
    removeHead(): void;
    removeTail(): void;
    remove(node: LinkedListNode<T>): void;
    clear(): void;
    private addNode;
    private extractNode;
    private nodesInternal;
    private nodesReverseInternal;
}
