var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { IteratorEnumerable } from '../enumerables/IteratorEnumerable';
import { Errors } from '../Errors';
import { LinkedListNodeInternal } from '../models/LinkedListNodeInternal';
import { Enumerable } from './Enumerable';
/**
 * Represents a linked list of objects.
 */
var LinkedList = /** @class */ (function (_super) {
    __extends(LinkedList, _super);
    function LinkedList(source) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        _this.sizeInternal = 0;
        if (source != null) {
            try {
                for (var source_1 = __values(source), source_1_1 = source_1.next(); !source_1_1.done; source_1_1 = source_1.next()) {
                    var item = source_1_1.value;
                    _this.addTail(item);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (source_1_1 && !source_1_1.done && (_a = source_1.return)) _a.call(source_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return _this;
    }
    LinkedList.prototype[Symbol.iterator] = function () {
        var node;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    node = this.headOrDefault;
                    _a.label = 1;
                case 1:
                    if (!(node != null)) return [3 /*break*/, 4];
                    return [4 /*yield*/, node.value];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    node = node.next;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    Object.defineProperty(LinkedList.prototype, "fromTail", {
        get: function () {
            return this.nodesFromTail.select(function (x) { return x.value; });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LinkedList.prototype, "nodes", {
        get: function () {
            return new IteratorEnumerable(this.nodesInternal());
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LinkedList.prototype, "nodesFromTail", {
        get: function () {
            return new IteratorEnumerable(this.nodesReverseInternal());
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LinkedList.prototype, "size", {
        get: function () {
            return this.sizeInternal;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LinkedList.prototype, "head", {
        get: function () {
            if (this.headInternal == null) {
                throw Errors.linkedListEmpty();
            }
            return this.headInternal;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LinkedList.prototype, "headOrDefault", {
        get: function () {
            return this.headInternal;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LinkedList.prototype, "tail", {
        get: function () {
            if (this.tailInternal == null) {
                throw Errors.linkedListEmpty();
            }
            return this.tailInternal;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(LinkedList.prototype, "tailOrDefault", {
        get: function () {
            return this.tailInternal;
        },
        enumerable: false,
        configurable: true
    });
    LinkedList.prototype.find = function (value) {
        var node = this.findOrDefault(value);
        if (node == null) {
            throw Errors.valueNotFoundLinkedList();
        }
        return node;
    };
    LinkedList.prototype.findOrDefault = function (value) {
        var node = this.nodes.firstOrDefault(function (x) { return x.value === value; });
        return node;
    };
    LinkedList.prototype.findLast = function (value) {
        var node = this.findLastOrDefault(value);
        if (node == null) {
            throw Errors.valueNotFoundLinkedList();
        }
        return node;
    };
    LinkedList.prototype.findLastOrDefault = function (value) {
        var node = this.nodes.reverse().firstOrDefault(function (x) { return x.value === value; });
        return node;
    };
    LinkedList.prototype.addHead = function (value) {
        this.addBefore(this.headInternal, value);
    };
    LinkedList.prototype.addTail = function (value) {
        this.addAfter(this.tailInternal, value);
    };
    LinkedList.prototype.addAfter = function (node, value) {
        var nodeInternal = this.extractNode(node);
        var newNode = new LinkedListNodeInternal(value, this, nodeInternal, nodeInternal === null || nodeInternal === void 0 ? void 0 : nodeInternal.nextInternal);
        this.addNode(newNode);
    };
    LinkedList.prototype.addBefore = function (node, value) {
        var nodeInternal = this.extractNode(node);
        var newNode = new LinkedListNodeInternal(value, this, nodeInternal === null || nodeInternal === void 0 ? void 0 : nodeInternal.previousInternal, nodeInternal);
        this.addNode(newNode);
    };
    LinkedList.prototype.removeHead = function () {
        this.remove(this.head);
    };
    LinkedList.prototype.removeTail = function () {
        this.remove(this.tail);
    };
    LinkedList.prototype.remove = function (node) {
        var n = this.extractNode(node);
        var prev = n.previousInternal;
        var next = n.nextInternal;
        if (prev != null) {
            prev.nextInternal = next;
        }
        if (next != null) {
            next.previousInternal = prev;
        }
        if (node === this.headInternal) {
            this.headInternal = next;
        }
        if (node === this.tailInternal) {
            this.tailInternal = prev;
        }
        --this.sizeInternal;
        n.previousInternal = undefined;
        n.nextInternal = undefined;
    };
    LinkedList.prototype.clear = function () {
        this.sizeInternal = 0;
        this.headInternal = this.tailInternal = undefined;
    };
    LinkedList.prototype.addNode = function (node) {
        if (node.previousInternal != null) {
            node.previousInternal.nextInternal = node;
        }
        if (node.nextInternal != null) {
            node.nextInternal.previousInternal = node;
        }
        if (node.previousInternal == null) {
            this.headInternal = node;
        }
        if (node.nextInternal == null) {
            this.tailInternal = node;
        }
        ++this.sizeInternal;
    };
    LinkedList.prototype.extractNode = function (node) {
        if (node == null) {
            return undefined;
        }
        if (node instanceof LinkedListNodeInternal) {
            if (node.linkedList === this) {
                return node;
            }
        }
        throw new Error('Node does not belong to LinkedList');
    };
    LinkedList.prototype.nodesInternal = function () {
        var node;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    node = this.headInternal;
                    _a.label = 1;
                case 1:
                    if (!(node != null)) return [3 /*break*/, 4];
                    return [4 /*yield*/, node];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    node = node.nextInternal;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    LinkedList.prototype.nodesReverseInternal = function () {
        var node;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    node = this.tailInternal;
                    _a.label = 1;
                case 1:
                    if (!(node != null)) return [3 /*break*/, 4];
                    return [4 /*yield*/, node];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    node = node.previousInternal;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    return LinkedList;
}(Enumerable));
export { LinkedList };
