var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ReadOnlyList } from './ReadOnlyList';
/**
 * Represents a list of objects that can be accessed by index.
 */
var List = /** @class */ (function (_super) {
    __extends(List, _super);
    function List() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    List.prototype.add = function (value) {
        this.source.push(value);
    };
    List.prototype.asReadOnly = function () {
        return this;
    };
    List.prototype.remove = function (index) {
        this.source.splice(index, 1);
    };
    List.prototype.set = function (index, value) {
        if (index < 0 || index >= this.source.length) {
            throw new Error('The index was out of range of the list.');
        }
        this.source[index] = value;
    };
    List.prototype.clear = function () {
        this.source.length = 0;
    };
    return List;
}(ReadOnlyList));
export { List };
