var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { Errors } from '../Errors';
import { Enumerable } from './Enumerable';
import { LinkedList } from './LinkedList';
/**
 * Represents a stack of objects.
 */
var Queue = /** @class */ (function (_super) {
    __extends(Queue, _super);
    function Queue(source) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        _this.source = new LinkedList();
        if (source != null) {
            try {
                for (var source_1 = __values(source), source_1_1 = source_1.next(); !source_1_1.done; source_1_1 = source_1.next()) {
                    var value = source_1_1.value;
                    _this.enqueue(value);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (source_1_1 && !source_1_1.done && (_a = source_1.return)) _a.call(source_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return _this;
    }
    Queue.prototype[Symbol.iterator] = function () {
        return this.source[Symbol.iterator]();
    };
    Object.defineProperty(Queue.prototype, "size", {
        get: function () {
            return this.source.size;
        },
        enumerable: false,
        configurable: true
    });
    Queue.prototype.peek = function () {
        if (this.size === 0) {
            throw Errors.queueEmpty();
        }
        return this.source.head.value;
    };
    Queue.prototype.dequeue = function () {
        if (this.size === 0) {
            throw Errors.queueEmpty();
        }
        var value = this.source.head.value;
        this.source.removeHead();
        return value;
    };
    Queue.prototype.enqueue = function (value) {
        this.source.addTail(value);
    };
    Queue.prototype.clear = function () {
        this.source.clear();
    };
    return Queue;
}(Enumerable));
export { Queue };
