import { EqualityComparer } from '../comparers/EqualityComparer';
import { Pair } from '../models/Pair';
import { Enumerable } from './Enumerable';
import { DictionaryAbstraction } from './internal/DictionaryAbstraction';
/**
 * Represents a read-only collection of keys and values. Values can be accessed by keys.
 */
// @ts-ignore
export declare class ReadOnlyDictionary<TKey, TValue> extends Enumerable<Pair<TKey, TValue>> {
    protected readonly innerDictionary: DictionaryAbstraction<TKey, TValue>;
    constructor();
    constructor(source?: Iterable<Pair<TKey, TValue>>);
    constructor(comparer?: EqualityComparer<TKey>);
    constructor(source?: Iterable<Pair<TKey, TValue>>, comparer?: EqualityComparer<TKey>);
    get size(): number;
    [Symbol.iterator](): Iterator<Pair<TKey, TValue>>;
    containsKey(key: TKey): boolean;
    get(key: TKey): TValue;
    getOrDefault(key: TKey): TValue | undefined;
    keys(): Enumerable<TKey>;
    values(): Enumerable<TValue>;
    protected addInternal(key: TKey, value: TValue): void;
}
