var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { DefaultEqualityComparer } from '../comparers/DefaultEqualityComparer';
import { EqualityComparer } from '../comparers/EqualityComparer';
import { SelectorEqualityComparer } from '../comparers/SelectorEqualityComparer';
import { Errors } from '../Errors';
import { Enumerable } from './Enumerable';
import { EqualityComparerDictionary } from './internal/EqualityComparerDictionary';
import { SelectorEqualityDictionary } from './internal/SelectorEqualityDictionary';
import { SimpleDictionary } from './internal/SimpleDictionary';
/**
 * Represents a read-only collection of keys and values. Values can be accessed by keys.
 */
// @ts-ignore
var ReadOnlyDictionary = /** @class */ (function (_super) {
    __extends(ReadOnlyDictionary, _super);
    function ReadOnlyDictionary(a, b) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        var source;
        var comparer;
        if (a instanceof EqualityComparer) {
            source = undefined;
            comparer = a;
        }
        else {
            source = a;
            comparer = b;
        }
        if (comparer == null || comparer instanceof DefaultEqualityComparer) {
            _this.innerDictionary = new SimpleDictionary();
        }
        else if (comparer instanceof SelectorEqualityComparer && comparer.innerComparer instanceof DefaultEqualityComparer) {
            // tslint:disable-next-line:no-any
            _this.innerDictionary = new SelectorEqualityDictionary(comparer.keySelector);
        }
        else {
            _this.innerDictionary = new EqualityComparerDictionary(comparer);
        }
        if (source != null) {
            try {
                for (var source_1 = __values(source), source_1_1 = source_1.next(); !source_1_1.done; source_1_1 = source_1.next()) {
                    var pair = source_1_1.value;
                    _this.addInternal(pair.key, pair.value);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (source_1_1 && !source_1_1.done && (_a = source_1.return)) _a.call(source_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return _this;
    }
    Object.defineProperty(ReadOnlyDictionary.prototype, "size", {
        get: function () {
            return this.innerDictionary.getSize();
        },
        enumerable: false,
        configurable: true
    });
    ReadOnlyDictionary.prototype[Symbol.iterator] = function () {
        return this.innerDictionary[Symbol.iterator]();
    };
    ReadOnlyDictionary.prototype.containsKey = function (key) {
        return this.innerDictionary.containsKey(key);
    };
    ReadOnlyDictionary.prototype.get = function (key) {
        var pair = this.innerDictionary.getPair(key);
        if (pair == null) {
            throw Errors.keyNotInDictionary();
        }
        return pair.value;
    };
    ReadOnlyDictionary.prototype.getOrDefault = function (key) {
        var pair = this.innerDictionary.getPair(key);
        return pair === null || pair === void 0 ? void 0 : pair.value;
    };
    ReadOnlyDictionary.prototype.keys = function () {
        return this.innerDictionary.keys();
    };
    ReadOnlyDictionary.prototype.values = function () {
        return this.innerDictionary.values();
    };
    ReadOnlyDictionary.prototype.addInternal = function (key, value) {
        if (this.containsKey(key)) {
            throw Errors.itemWithKeyAlreadyAdded();
        }
        this.innerDictionary.set(key, value);
    };
    return ReadOnlyDictionary;
}(Enumerable));
export { ReadOnlyDictionary };
