import { EqualityComparer } from '../comparers/EqualityComparer';
import { Enumerable } from './Enumerable';
import { HashSetAbstraction } from './internal/HashSetAbstraction';
/**
 * Represents a read-only set of values.
 */
export declare class ReadOnlyHashSet<T> extends Enumerable<T> {
    protected readonly internalHashSet: HashSetAbstraction<T>;
    constructor();
    constructor(source?: Iterable<T>);
    constructor(comparer?: EqualityComparer<T>);
    constructor(source?: Iterable<T>, comparer?: EqualityComparer<T>);
    [Symbol.iterator](): Iterator<T>;
    get size(): number;
    contains(element: T): boolean;
    protected addInternal(element: T): void;
}
