var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { DefaultEqualityComparer } from '../comparers/DefaultEqualityComparer';
import { EqualityComparer } from '../comparers/EqualityComparer';
import { SelectorEqualityComparer } from '../comparers/SelectorEqualityComparer';
import { Errors } from '../Errors';
import { Enumerable } from './Enumerable';
import { EqualityComparerHashSet } from './internal/EqualityComparerHashSet';
import { SelectorEqualityHashSet } from './internal/SelectorEqualityHashSet';
import { SimpleHashSet } from './internal/SimpleHashSet';
/**
 * Represents a read-only set of values.
 */
var ReadOnlyHashSet = /** @class */ (function (_super) {
    __extends(ReadOnlyHashSet, _super);
    function ReadOnlyHashSet(a, b) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        var source;
        var comparer;
        if (a instanceof EqualityComparer) {
            source = undefined;
            comparer = a;
        }
        else {
            source = a;
            comparer = b;
        }
        if (comparer == null || comparer instanceof DefaultEqualityComparer) {
            _this.internalHashSet = new SimpleHashSet();
        }
        else if (comparer instanceof SelectorEqualityComparer && comparer.innerComparer instanceof DefaultEqualityComparer) {
            // tslint:disable-next-line:no-any
            _this.internalHashSet = new SelectorEqualityHashSet(comparer.keySelector);
        }
        else {
            _this.internalHashSet = new EqualityComparerHashSet(comparer);
        }
        if (source != null) {
            try {
                for (var source_1 = __values(source), source_1_1 = source_1.next(); !source_1_1.done; source_1_1 = source_1.next()) {
                    var element = source_1_1.value;
                    _this.addInternal(element);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (source_1_1 && !source_1_1.done && (_a = source_1.return)) _a.call(source_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return _this;
    }
    ReadOnlyHashSet.prototype[Symbol.iterator] = function () {
        return this.internalHashSet[Symbol.iterator]();
    };
    Object.defineProperty(ReadOnlyHashSet.prototype, "size", {
        get: function () {
            return this.internalHashSet.getSize();
        },
        enumerable: false,
        configurable: true
    });
    ReadOnlyHashSet.prototype.contains = function (element) {
        return this.internalHashSet.contains(element);
    };
    ReadOnlyHashSet.prototype.addInternal = function (element) {
        if (this.contains(element)) {
            throw Errors.elementAlreadyAdded();
        }
        this.internalHashSet.set(element);
    };
    return ReadOnlyHashSet;
}(Enumerable));
export { ReadOnlyHashSet };
