var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ArrayEnumerable } from '../enumerables/ArrayEnumerable';
import { Errors } from '../Errors';
/**
 * Represents a read-only linked list of objects.
 */
var ReadOnlyList = /** @class */ (function (_super) {
    __extends(ReadOnlyList, _super);
    function ReadOnlyList(source) {
        return _super.call(this, Array.from(source !== null && source !== void 0 ? source : [])) || this;
    }
    Object.defineProperty(ReadOnlyList.prototype, "size", {
        get: function () {
            return this.source.length;
        },
        enumerable: false,
        configurable: true
    });
    ReadOnlyList.prototype.containsIndex = function (index) {
        if (Math.round(index) !== index) {
            throw Errors.indexNotInteger();
        }
        return index >= 0 && index < this.source.length;
    };
    ReadOnlyList.prototype.get = function (index) {
        if (!this.containsIndex(index)) {
            throw Errors.indexOutOfRange();
        }
        return this.source[index];
    };
    ReadOnlyList.prototype.getOrDefault = function (index) {
        if (!this.containsIndex(index)) {
            return undefined;
        }
        return this.source[index];
    };
    return ReadOnlyList;
}(ArrayEnumerable));
export { ReadOnlyList };
