import { EqualityComparer } from '../../comparers/EqualityComparer';
import { Pair } from '../../models/Pair';
import { Enumerable } from '../Enumerable';
import { List } from '../List';
import { DictionaryAbstraction } from './DictionaryAbstraction';
export declare class EqualityComparerDictionary<TKey, TValue> implements DictionaryAbstraction<TKey, TValue> {
    protected readonly buckets: Map<number, List<Pair<TKey, TValue>>>;
    protected readonly comparer: EqualityComparer<TKey>;
    protected sizeInternal: number;
    constructor(comparer: EqualityComparer<TKey>);
    [Symbol.iterator](): Iterator<Pair<TKey, TValue>>;
    clear(): void;
    containsKey(key: TKey): boolean;
    getPair(key: TKey): Pair<TKey, TValue> | undefined;
    getSize(): number;
    keys(): Enumerable<TKey>;
    remove(key: TKey): boolean;
    set(key: TKey, value: TValue): void;
    values(): Enumerable<TValue>;
}
