var SelectorEqualityHashSet = /** @class */ (function () {
    function SelectorEqualityHashSet(keySelector) {
        this.keySelector = keySelector;
        this.source = new Map();
    }
    SelectorEqualityHashSet.prototype[Symbol.iterator] = function () {
        return this.source.values();
    };
    SelectorEqualityHashSet.prototype.clear = function () {
        this.source.clear();
    };
    SelectorEqualityHashSet.prototype.contains = function (element) {
        return this.source.has(this.keySelector(element));
    };
    SelectorEqualityHashSet.prototype.getSize = function () {
        return this.source.size;
    };
    SelectorEqualityHashSet.prototype.remove = function (element) {
        return this.source.delete(this.keySelector(element));
    };
    SelectorEqualityHashSet.prototype.set = function (element) {
        this.source.set(this.keySelector(element), element);
    };
    return SelectorEqualityHashSet;
}());
export { SelectorEqualityHashSet };
