import { Pair } from '../../models/Pair';
import { Enumerable } from '../Enumerable';
import { DictionaryAbstraction } from './DictionaryAbstraction';
export declare class SimpleDictionary<TKey, TValue> implements DictionaryAbstraction<TKey, TValue> {
    private readonly source;
    [Symbol.iterator](): Iterator<Pair<TKey, TValue>>;
    clear(): void;
    containsKey(key: TKey): boolean;
    getPair(key: TKey): Pair<TKey, TValue> | undefined;
    getSize(): number;
    keys(): Enumerable<TKey>;
    remove(key: TKey): boolean;
    set(key: TKey, value: TValue): void;
    values(): Enumerable<TValue>;
}
