import { Pair } from '../../models/Pair';
import { Enumerable } from '../Enumerable';
var SimpleDictionary = /** @class */ (function () {
    function SimpleDictionary() {
        this.source = new Map();
    }
    SimpleDictionary.prototype[Symbol.iterator] = function () {
        return this.source.values();
    };
    SimpleDictionary.prototype.clear = function () {
        this.source.clear();
    };
    SimpleDictionary.prototype.containsKey = function (key) {
        return this.source.has(key);
    };
    SimpleDictionary.prototype.getPair = function (key) {
        return this.source.get(key);
    };
    SimpleDictionary.prototype.getSize = function () {
        return this.source.size;
    };
    SimpleDictionary.prototype.keys = function () {
        return Enumerable.from(this.source.keys());
    };
    SimpleDictionary.prototype.remove = function (key) {
        return this.source.delete(key);
    };
    SimpleDictionary.prototype.set = function (key, value) {
        this.source.set(key, Pair.from(key, value));
    };
    SimpleDictionary.prototype.values = function () {
        return Enumerable.from(this.source.values())
            .select(function (x) { return x.value; });
    };
    return SimpleDictionary;
}());
export { SimpleDictionary };
