var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { Enumerable } from '../collections/Enumerable';
import { HashCode } from '../hashing/HashCode';
import { EqualityComparer } from './EqualityComparer';
var ShallowEqualityComparer = /** @class */ (function (_super) {
    __extends(ShallowEqualityComparer, _super);
    function ShallowEqualityComparer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ShallowEqualityComparer.prototype.equals = function (value1, value2) {
        var e_1, _a;
        if (typeof value1 !== typeof value2) {
            return false;
        }
        if (typeof value1 !== 'object') {
            return value1 === value2;
        }
        var keys1 = Object.getOwnPropertyNames(value1);
        var keys2 = Object.getOwnPropertyNames(value1);
        if (keys1.length !== keys2.length) {
            return false;
        }
        try {
            for (var _b = __values(keys1.concat.apply(keys1, __spreadArray([], __read(keys2)))), _c = _b.next(); !_c.done; _c = _b.next()) {
                var key = _c.value;
                // @ts-ignore
                if (value1[key] !== value2[key]) {
                    return false;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    };
    ShallowEqualityComparer.prototype.getHashCode = function (value) {
        if (typeof value !== 'object') {
            return HashCode.getHashCode(value);
        }
        var hashCodes = Enumerable.from(Object.getOwnPropertyNames(value))
            .orderBy(function (x) { return x; })
            // @ts-ignore
            .selectMany(function (x) { return [x, value[x]]; })
            .select(function (x) { return HashCode.getHashCode(x); });
        return HashCode.combine(hashCodes);
    };
    return ShallowEqualityComparer;
}(EqualityComparer));
export { ShallowEqualityComparer };
