import { Enumerable } from '../collections/Enumerable';
import { FullJoinElement } from '../models/FullJoinElement';
export declare class FullJoinEnumerable<TLeft, TRight, TKey, TResult = FullJoinElement<TLeft, TRight>> extends Enumerable<TResult> {
    private readonly leftSource;
    private readonly rightSource;
    private readonly leftKeySelector;
    private readonly rightKeySelector;
    private readonly resultSelector?;
    constructor(leftSource: Iterable<TLeft>, rightSource: Iterable<TRight>, leftKeySelector: (value: TLeft, index: number) => TKey, rightKeySelector: (value: TRight, index: number) => TKey, resultSelector?: ((left: TLeft | undefined, right: TRight | undefined) => TResult) | undefined);
    [Symbol.iterator](): Iterator<TResult>;
}
