import { Enumerable } from '../collections/Enumerable';
import { Grouping } from '../collections/Grouping';
import { EqualityComparer } from '../comparers/EqualityComparer';
export declare class GroupByEnumerable<TKey, TValue, TElement = TValue, TResult = Grouping<TKey, TElement>> extends Enumerable<TResult> {
    private readonly source;
    private readonly keySelector;
    private readonly keyEqualityComparer?;
    private readonly elementSelector?;
    private readonly resultSelector?;
    constructor(source: Iterable<TValue>, keySelector: (value: TValue, index: number) => TKey, keyEqualityComparer?: EqualityComparer<unknown> | undefined, elementSelector?: ((value: TValue, index: number) => TElement) | undefined, resultSelector?: ((key: TKey, group: Enumerable<TElement>) => TResult) | undefined);
    [Symbol.iterator](): Iterator<TResult>;
}
