var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { Dictionary } from '../collections/Dictionary';
import { Enumerable } from '../collections/Enumerable';
import { Grouping } from '../collections/Grouping';
var GroupByEnumerable = /** @class */ (function (_super) {
    __extends(GroupByEnumerable, _super);
    function GroupByEnumerable(source, keySelector, keyEqualityComparer, elementSelector, resultSelector) {
        var _this = _super.call(this) || this;
        _this.source = source;
        _this.keySelector = keySelector;
        _this.keyEqualityComparer = keyEqualityComparer;
        _this.elementSelector = elementSelector;
        _this.resultSelector = resultSelector;
        return _this;
    }
    GroupByEnumerable.prototype[Symbol.iterator] = function () {
        var e_1, _a;
        var _b;
        var dict = new Dictionary(this.keyEqualityComparer);
        var index = 0;
        try {
            for (var _c = __values(this.source), _d = _c.next(); !_d.done; _d = _c.next()) {
                var element = _d.value;
                var key = this.keySelector(element, index++);
                if (!dict.containsKey(key)) {
                    dict.add(key, new Grouping(key));
                }
                var mappedElement = this.elementSelector != null ? this.elementSelector(element, index) : element;
                dict.get(key).add(mappedElement);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var resSelector = (_b = this.resultSelector) !== null && _b !== void 0 ? _b : (function (key, group) { return new Grouping(key, group); });
        var result = dict.select(function (pair) { return resSelector(pair.key, pair.value); });
        return result[Symbol.iterator]();
    };
    return GroupByEnumerable;
}(Enumerable));
export { GroupByEnumerable };
