import { Enumerable } from '../collections/Enumerable';
import { ReadOnlyList } from '../collections/ReadOnlyList';
import { GroupJoinElement } from '../models/GroupJoinElement';
export declare class GroupJoinEnumerable<TLeft, TRight, TKey, TResult = GroupJoinElement<TLeft, TRight>> extends Enumerable<TResult> {
    private readonly leftSource;
    private readonly rightSource;
    private readonly leftKeySelector;
    private readonly rightKeySelector;
    private readonly resultSelector?;
    constructor(leftSource: Iterable<TLeft>, rightSource: Iterable<TRight>, leftKeySelector: (value: TLeft, index: number) => TKey, rightKeySelector: (value: TRight, index: number) => TKey, resultSelector?: ((left: TLeft, rightList: ReadOnlyList<TRight>) => TResult) | undefined);
    [Symbol.iterator](): Iterator<TResult>;
}
