import { Enumerable } from '../collections/Enumerable';
import { JoinElement } from '../models/JoinElement';
export declare class JoinEnumerable<TLeft, TRight, TKey, TResult = JoinElement<TLeft, TRight>> extends Enumerable<TResult> {
    private readonly leftSource;
    private readonly rightSource;
    private readonly leftKeySelector;
    private readonly rightKeySelector;
    private readonly resultSelector?;
    constructor(leftSource: Iterable<TLeft>, rightSource: Iterable<TRight>, leftKeySelector: (value: TLeft, index: number) => TKey, rightKeySelector: (value: TRight, index: number) => TKey, resultSelector?: ((left: TLeft, right: TRight) => TResult) | undefined);
    [Symbol.iterator](): Iterator<TResult>;
}
