import { Enumerable } from '../collections/Enumerable';
import { LeftJoinElement } from '../models/LeftJoinElement';
export declare class LeftJoinEnumerable<TLeft, TRight, TKey, TResult = LeftJoinElement<TLeft, TRight>> extends Enumerable<TResult> {
    private readonly leftSource;
    private readonly rightSource;
    private readonly leftKeySelector;
    private readonly rightKeySelector;
    private readonly resultSelector?;
    constructor(leftSource: Iterable<TLeft>, rightSource: Iterable<TRight>, leftKeySelector: (value: TLeft, index: number) => TKey, rightKeySelector: (value: TRight, index: number) => TKey, resultSelector?: ((left: TLeft, right: TRight | undefined) => TResult) | undefined);
    [Symbol.iterator](): Iterator<TResult>;
}
