import { Enumerable } from '../collections/Enumerable';
import { RightJoinElement } from '../models/RightJoinElement';
export declare class RightJoinEnumerable<TLeft, TRight, TKey, TResult = RightJoinElement<TLeft, TRight>> extends Enumerable<TResult> {
    private readonly leftSource;
    private readonly rightSource;
    private readonly leftKeySelector;
    private readonly rightKeySelector;
    private readonly resultSelector?;
    constructor(leftSource: Iterable<TLeft>, rightSource: Iterable<TRight>, leftKeySelector: (value: TLeft, index: number) => TKey, rightKeySelector: (value: TRight, index: number) => TKey, resultSelector?: ((left: TLeft | undefined, right: TRight) => TResult) | undefined);
    [Symbol.iterator](): Iterator<TResult>;
}
