import { FullJoinElement } from '../../models/FullJoinElement';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Performs a full outer join on two homogeneous sequences. */
        fullJoin<TRight, TKey, TResult = FullJoinElement<T, TRight>>(rightSource: Iterable<TRight>, leftKeySelector: (value: T, index: number) => TKey, rightKeySelector: (value: TRight, index: number) => TKey, resultSelector?: (left: T | undefined, right: TRight | undefined) => TResult): Enumerable<TResult>;
    }
}
