import { Grouping } from '../../collections/Grouping';
import { EqualityComparer } from '../../comparers/EqualityComparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Groups the elements of a sequence according to a specified key selector function and creates a result value from each group and its key. */
        groupBy<TKey, TElement = T, TResult = Grouping<TKey, TElement>>(keySelector: (value: T, index: number) => TKey, keyEqualityComparer: EqualityComparer, elementSelector?: (value: T, index: number) => TElement, resultSelector?: (key: TKey, group: Enumerable<TElement>) => TResult): Enumerable<TResult>;
        /** Groups the elements of a sequence according to a specified key selector function and creates a result value from each group and its key. */
        groupBy<TKey, TElement = T, TResult = Grouping<TKey, TElement>>(keySelector: (value: T, index: number) => TKey, elementSelector?: (value: T, index: number) => TElement, resultSelector?: (key: TKey, group: Enumerable<TElement>) => TResult): Enumerable<TResult>;
    }
}
