import { ReadOnlyList } from '../../collections/ReadOnlyList';
import { GroupJoinElement } from '../../models/GroupJoinElement';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Correlates the elements of two sequences based on equality of keys and groups the results. */
        groupJoin<TRight, TKey, TResult = GroupJoinElement<T, TRight>>(rightSource: Iterable<TRight>, leftKeySelector: (value: T, index: number) => TKey, rightKeySelector: (value: TRight, index: number) => TKey, resultSelector?: (left: T, rightList: ReadOnlyList<TRight>) => TResult): Enumerable<TResult>;
    }
}
