import { ReadOnlyList } from '../../collections/ReadOnlyList';
import { LeftGroupJoinElement } from '../../models/LeftGroupJoinElement';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Correlates the elements of two sequences based on equality of keys and groups the results. */
        leftGroupJoin<TRight, TKey, TResult = LeftGroupJoinElement<T, TRight>>(rightSource: Iterable<TRight>, leftKeySelector: (value: T, index: number) => TKey, rightKeySelector: (value: TRight, index: number) => TKey, resultSelector?: (left: T, rightList: ReadOnlyList<TRight> | undefined) => TResult): Enumerable<TResult>;
    }
}
