import { Enumerable } from '../../collections/Enumerable';
import { EqualityComparer } from '../../comparers/EqualityComparer';
function sequenceEqual(secondSource, comparer) {
    var cmp = comparer !== null && comparer !== void 0 ? comparer : EqualityComparer.getDefault();
    var iterator1 = this[Symbol.iterator]();
    var iterator2 = secondSource[Symbol.iterator]();
    var i1 = iterator1.next();
    var i2 = iterator2.next();
    for (; i1.done !== true && i2.done !== true; i1 = iterator1.next(), i2 = iterator2.next()) {
        if (!cmp.equals(i1.value, i2.value)) {
            return false;
        }
    }
    if (i1.done !== true || i2.done !== true) {
        return false;
    }
    return true;
}
Enumerable.prototype.sequenceEqual = sequenceEqual;
