declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /**
         *  Returns the only element of a sequence that satisfies a specified condition or
         *  undefined if no such element exists; this method throws an exception if
         *  more than one element satisfies the condition.
         */
        singleOrDefault(predicate?: (x: T, index: number) => boolean): T | undefined;
    }
}
export {};
