import { Dictionary } from '../../collections/Dictionary';
import { Enumerable } from '../../collections/Enumerable';
import { EqualityComparer } from '../../comparers/EqualityComparer';
import { Pair } from '../../models/Pair';
function toDictionary(keySelector, valueSelector, comparer) {
    if (valueSelector instanceof EqualityComparer) {
        return toDictionaryStrict(this, keySelector, undefined, valueSelector);
    }
    return toDictionaryStrict(this, keySelector, valueSelector, comparer);
}
function toDictionaryStrict(source, keySelector, valueSelector, comparer) {
    var pairs = source.select(function (x, idx) { return Pair.from(keySelector(x, idx), valueSelector != null ? valueSelector(x, idx) : x); });
    return new Dictionary(pairs, comparer);
}
Enumerable.prototype.toDictionary = toDictionary;
