import { ReadOnlyDictionary } from '../../collections/ReadOnlyDictionary';
import { EqualityComparer } from '../../comparers/EqualityComparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Converts sequence to a ReadOnlyDictionary. */
        toReadOnlyDictionary<TKey, TValue = T>(keySelector: (element: T, index: number) => TKey, comparer?: EqualityComparer<TKey>): ReadOnlyDictionary<TKey, TValue>;
        /** Converts sequence to a ReadOnlyDictionary. */
        toReadOnlyDictionary<TKey, TValue = T>(keySelector: (element: T, index: number) => TKey, valueSelector?: (element: T, index: number) => TValue, comparer?: EqualityComparer<TKey>): ReadOnlyDictionary<TKey, TValue>;
    }
}
