import { Enumerable } from '../../collections/Enumerable';
import { ReadOnlyDictionary } from '../../collections/ReadOnlyDictionary';
import { EqualityComparer } from '../../comparers/EqualityComparer';
import { Pair } from '../../models/Pair';
function toReadOnlyDictionary(keySelector, valueSelector, comparer) {
    if (valueSelector instanceof EqualityComparer) {
        return toReadOnlyDictionaryStrict(this, keySelector, undefined, valueSelector);
    }
    return toReadOnlyDictionaryStrict(this, keySelector, valueSelector, comparer);
}
function toReadOnlyDictionaryStrict(source, keySelector, valueSelector, comparer) {
    var pairs = source.select(function (x, idx) { return Pair.from(keySelector(x, idx), valueSelector != null ? valueSelector(x, idx) : x); });
    return new ReadOnlyDictionary(pairs, comparer);
}
Enumerable.prototype.toReadOnlyDictionary = toReadOnlyDictionary;
