import { Enumerable } from '../../../collections/Enumerable';
import { ArrayEnumerable } from '../../../enumerables/ArrayEnumerable';
import { IterableEnumerable } from '../../../enumerables/IterableEnumerable';
import { MapEnumerable } from '../../../enumerables/MapEnumerable';
import { SetEnumerable } from '../../../enumerables/SetEnumerable';
function from(source) {
    if (Array.isArray(source)) {
        return new ArrayEnumerable(source);
    }
    if (source instanceof Set) {
        return new SetEnumerable(source);
    }
    if (source instanceof Map) {
        // @ts-ignore
        return new MapEnumerable(source);
    }
    return new IterableEnumerable(source);
}
Enumerable.from = from;
