/* tslint:disable:no-bitwise */
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { Enumerable } from '../collections/Enumerable';
var HashCode = /** @class */ (function () {
    function HashCode() {
    }
    HashCode.getHashCode = function (value) {
        if (value == null) {
            return 561691612;
        }
        switch (typeof value) {
            case 'boolean': return HashCode.hashBoolean(value, 2354214525);
            case 'number': return HashCode.hashNumber(value, 1312455877);
            case 'string': return HashCode.hashString(value, 1745632457);
            case 'object': return HashCode.hashObject(value, 2031456879);
            case 'function': return HashCode.hashObject(value, 1426754523);
            case 'symbol': return HashCode.hashString(value.toString(), 1942554899);
            default: throw new Error("Not supported type for hashing (" + typeof value + ")");
        }
    };
    HashCode.combine = function (hashCodes) {
        return HashCode.combineInner(hashCodes, 0);
    };
    HashCode.combineRest = function () {
        var hashCodes = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            hashCodes[_i] = arguments[_i];
        }
        return HashCode.combineInner(hashCodes, 0);
    };
    HashCode.hashBoolean = function (bool, seed) {
        return HashCode.hashNumber(bool ? 1 : 0, seed);
    };
    HashCode.hashNumber = function (num, seed) {
        if (Number.isFinite(num)) {
            return HashCode.combineInner(Enumerable.single(num), seed);
        }
        return 0;
    };
    HashCode.hashString = function (value, seed) {
        var charCodes = Enumerable.from(value).select(function (x) { return x.charCodeAt(0); });
        return HashCode.combineInner(charCodes, seed); // TODO test
    };
    HashCode.hashObject = function (value, seed) {
        var hashCode = HashCode.objectHashCodes.get(value);
        if (hashCode == null) {
            hashCode = HashCode.hashNumber(++HashCode.lastHashCode, seed);
            HashCode.objectHashCodes.set(value, hashCode);
        }
        return hashCode;
    };
    // source: https://stackoverflow.com/a/52171480/2262449
    HashCode.combineInner = function (source, seed) {
        var e_1, _a;
        var h1 = seed ^ 0xDEADBEEF;
        var h2 = seed ^ 0x41C6CE57;
        try {
            for (var source_1 = __values(source), source_1_1 = source_1.next(); !source_1_1.done; source_1_1 = source_1.next()) {
                var hashCode = source_1_1.value;
                h1 = Math.imul(h1 ^ hashCode, 2654435761);
                h2 = Math.imul(h2 ^ hashCode, 1597334677);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (source_1_1 && !source_1_1.done && (_a = source_1.return)) _a.call(source_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        h1 = Math.imul(h1 ^ (h1 >>> 16), 2246822507) ^ Math.imul(h2 ^ (h2 >>> 13), 3266489909);
        h2 = Math.imul(h2 ^ (h2 >>> 16), 2246822507) ^ Math.imul(h1 ^ (h1 >>> 13), 3266489909);
        return (h2 & 2097151) * 4294967296 + (h1 >>> 0);
    };
    HashCode.lastHashCode = 0;
    HashCode.objectHashCodes = new WeakMap();
    return HashCode;
}());
export { HashCode };
